"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _plugin = require("@unofficial-parcel-nightly/plugin");

var _assert = _interopRequireDefault(require("assert"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

async function shouldExclude(asset, options) {
  if (!asset.isSource || !options.hot || !asset.env.isBrowser() || options.mode !== 'development') {
    return true;
  } else {
    let pkg = await asset.getPackage();
    return !(pkg && pkg.dependencies && pkg.dependencies['react']);
  }
}

var _default = new _plugin.Transformer({
  async transform({
    asset,
    options
  }) {
    if (!(await shouldExclude(asset, options))) {
      let reactRefreshBabelPlugin = (await options.packageManager.resolve('react-refresh/babel', __filename)).resolved;
      asset.meta.babelPlugins = asset.meta.babelPlugins || [];
      (0, _assert.default)(Array.isArray(asset.meta.babelPlugins));
      asset.meta.babelPlugins.push([reactRefreshBabelPlugin, {
        skipEnvCheck: true
      }]);
    }

    return [asset];
  }

});

exports.default = _default;